=== Makefile ===
# This file is generated by tools/dmake, do not edit.

# To compile with rules, use 'make HAVE_RULES=yes'
ifndef HAVE_RULES
    HAVE_RULES=no
endif

ifndef USE_Z3
    USE_Z3=no
endif

ifeq ($(USE_Z3),yes)
    CPPFLAGS += -DUSE_Z3
    LIBS += -lz3
endif
# use match compiler
ifeq ($(SRCDIR),build)
    $(warning Usage of SRCDIR to activate match compiler is deprecated. Use MATCHCOMPILER=yes instead.)
    MATCHCOMPILER:=yes
endif
ifeq ($(MATCHCOMPILER),yes)
    # Find available Python interpreter
    PYTHON_INTERPRETER := $(shell which python)
    ifndef PYTHON_INTERPRETER
        PYTHON_INTERPRETER := $(shell which python3)
    endif
    ifndef PYTHON_INTERPRETER
        $(error Did not find a Python interpreter)
    endif
    ifdef VERIFY
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py --verify)
    else
        matchcompiler_S := $(shell $(PYTHON_INTERPRETER) tools/matchcompiler.py)
    endif
    libcppdir:=build
else
    libcppdir:=lib
endif

ifdef FILESDIR
    CPPFILESDIR=-DFILESDIR=\"$(FILESDIR)\"
else
    CPPFILESDIR=
endif

RDYNAMIC=-rdynamic
# Set the CPPCHK_GLIBCXX_DEBUG flag. This flag is not used in release Makefiles.
# The _GLIBCXX_DEBUG define doesn't work in Cygwin or other Win32 systems.
ifndef COMSPEC
    ifdef ComSpec
        #### ComSpec is defined on some WIN32's.
        COMSPEC=$(ComSpec)
    endif # ComSpec
endif # COMSPEC

ifdef COMSPEC
    #### Maybe Windows
    ifndef CPPCHK_GLIBCXX_DEBUG
        CPPCHK_GLIBCXX_DEBUG=
    endif # !CPPCHK_GLIBCXX_DEBUG

    ifeq ($(MSYSTEM),MINGW32 MINGW64)
        LDFLAGS=-lshlwapi
    else
        RDYNAMIC=-lshlwapi
    endif
else # !COMSPEC
    uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

    ifeq ($(uname_S),Linux)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # Linux

    ifeq ($(uname_S),GNU/kFreeBSD)
        ifndef CPPCHK_GLIBCXX_DEBUG
            CPPCHK_GLIBCXX_DEBUG=-D_GLIBCXX_DEBUG
        endif # !CPPCHK_GLIBCXX_DEBUG
    endif # GNU/kFreeBSD

endif # COMSPEC

# Set the UNDEF_STRICT_ANSI flag to address compile time warnings
# with tinyxml2 and Cygwin.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        UNDEF_STRICT_ANSI=-U__STRICT_ANSI__
    endif # CYGWIN
endif # COMSPEC

ifndef CXX
    CXX=g++
endif

ifeq (clang++, $(findstring clang++,$(CXX)))
    CPPCHK_GLIBCXX_DEBUG=
endif
ifndef CXXFLAGS
    CXXFLAGS=-std=c++0x -O2 -DNDEBUG -Wall -Wno-sign-compare
endif

# Increase stack size for Cygwin builds to avoid segmentation fault in limited recursive tests.
ifdef COMSPEC
    uname_S := $(shell uname -s)

    ifneq (,$(findstring CYGWIN,$(uname_S)))
        CXXFLAGS+=-Wl,--stack,8388608
    endif # CYGWIN
endif # COMSPEC

ifeq (g++, $(findstring g++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq (clang++, $(findstring clang++,$(CXX)))
    override CXXFLAGS += -std=c++0x
else ifeq ($(CXX), c++)
    ifeq ($(shell uname -s), Darwin)
        override CXXFLAGS += -std=c++0x
    endif
endif

ifeq ($(HAVE_RULES),yes)
    override CXXFLAGS += -DHAVE_RULES -DTIXML_USE_STL $(shell pcre-config --cflags)
    ifdef LIBS
        LIBS += $(shell pcre-config --libs)
    else
        LIBS=$(shell pcre-config --libs)
    endif
endif

ifndef PREFIX
    PREFIX=/usr
endif

ifndef INCLUDE_FOR_LIB
    INCLUDE_FOR_LIB=-Ilib -isystem externals -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_CLI
    INCLUDE_FOR_CLI=-Ilib -isystem externals/simplecpp -isystem externals/tinyxml
endif

ifndef INCLUDE_FOR_TEST
    INCLUDE_FOR_TEST=-Ilib -Icli -isystem externals/simplecpp -isystem externals/tinyxml
endif

BIN=$(DESTDIR)$(PREFIX)/bin

# For 'make man': sudo apt-get install xsltproc docbook-xsl docbook-xml on Linux
DB2MAN?=/usr/share/sgml/docbook/stylesheet/xsl/nwalsh/manpages/docbook.xsl
XP=xsltproc -''-nonet -''-param man.charmap.use.subset "0"
MAN_SOURCE=man/cppcheck.1.xml


###### Object Files

LIBOBJ =      $(libcppdir)/analyzerinfo.o \
              $(libcppdir)/astutils.o \
              $(libcppdir)/check.o \
              $(libcppdir)/check64bit.o \
              $(libcppdir)/checkassert.o \
              $(libcppdir)/checkautovariables.o \
              $(libcppdir)/checkbool.o \
              $(libcppdir)/checkboost.o \
              $(libcppdir)/checkbufferoverrun.o \
              $(libcppdir)/checkclass.o \
              $(libcppdir)/checkcondition.o \
              $(libcppdir)/checkexceptionsafety.o \
              $(libcppdir)/checkfunctions.o \
              $(libcppdir)/checkinternal.o \
              $(libcppdir)/checkio.o \
              $(libcppdir)/checkleakautovar.o \
              $(libcppdir)/checkmemoryleak.o \
              $(libcppdir)/checknullpointer.o \
              $(libcppdir)/checkother.o \
              $(libcppdir)/checkpostfixoperator.o \
              $(libcppdir)/checksizeof.o \
              $(libcppdir)/checkstl.o \
              $(libcppdir)/checkstring.o \
              $(libcppdir)/checktype.o \
              $(libcppdir)/checkuninitvar.o \
              $(libcppdir)/checkunusedfunctions.o \
              $(libcppdir)/checkunusedvar.o \
              $(libcppdir)/checkvaarg.o \
              $(libcppdir)/clangimport.o \
              $(libcppdir)/cppcheck.o \
              $(libcppdir)/ctu.o \
              $(libcppdir)/errorlogger.o \
              $(libcppdir)/exprengine.o \
              $(libcppdir)/forwardanalyzer.o \
              $(libcppdir)/importproject.o \
              $(libcppdir)/library.o \
              $(libcppdir)/mathlib.o \
              $(libcppdir)/path.o \
              $(libcppdir)/pathanalysis.o \
              $(libcppdir)/pathmatch.o \
              $(libcppdir)/platform.o \
              $(libcppdir)/preprocessor.o \
              $(libcppdir)/programmemory.o \
              $(libcppdir)/settings.o \
              $(libcppdir)/suppressions.o \
              $(libcppdir)/symboldatabase.o \
              $(libcppdir)/templatesimplifier.o \
              $(libcppdir)/timer.o \
              $(libcppdir)/token.o \
              $(libcppdir)/tokenize.o \
              $(libcppdir)/tokenlist.o \
              $(libcppdir)/valueflow.o

EXTOBJ =      externals/simplecpp/simplecpp.o \
              externals/tinyxml/tinyxml2.o

CLIOBJ =      cli/cmdlineparser.o \
              cli/cppcheckexecutor.o \
              cli/filelister.o \
              cli/main.o \
              cli/threadexecutor.o

TESTOBJ =     test/options.o \
              test/test64bit.o \
              test/testassert.o \
              test/testastutils.o \
              test/testautovariables.o \
              test/testbool.o \
              test/testboost.o \
              test/testbufferoverrun.o \
              test/testcharvar.o \
              test/testclangimport.o \
              test/testclass.o \
              test/testcmdlineparser.o \
              test/testcondition.o \
              test/testconstructors.o \
              test/testcppcheck.o \
              test/testerrorlogger.o \
              test/testexceptionsafety.o \
              test/testexprengine.o \
              test/testfilelister.o \
              test/testfunctions.o \
              test/testgarbage.o \
              test/testimportproject.o \
              test/testincompletestatement.o \
              test/testinternal.o \
              test/testio.o \
              test/testleakautovar.o \
              test/testlibrary.o \
              test/testmathlib.o \
              test/testmemleak.o \
              test/testnullpointer.o \
              test/testoptions.o \
              test/testother.o \
              test/testpath.o \
              test/testpathmatch.o \
              test/testplatform.o \
              test/testpostfixoperator.o \
              test/testpreprocessor.o \
              test/testrunner.o \
              test/testsamples.o \
              test/testsimplifytemplate.o \
              test/testsimplifytokens.o \
              test/testsimplifytypedef.o \
              test/testsimplifyusing.o \
              test/testsizeof.o \
              test/teststl.o \
              test/teststring.o \
              test/testsuite.o \
              test/testsuppressions.o \
              test/testsymboldatabase.o \
              test/testthreadexecutor.o \
              test/testtimer.o \
              test/testtoken.o \
              test/testtokenize.o \
              test/testtokenlist.o \
              test/testtype.o \
              test/testuninitvar.o \
              test/testunusedfunctions.o \
              test/testunusedprivfunc.o \
              test/testunusedvar.o \
              test/testutils.o \
              test/testvaarg.o \
              test/testvalueflow.o \
              test/testvarid.o

.PHONY: run-dmake tags


###### Targets

cppcheck: $(LIBOBJ) $(CLIOBJ) $(EXTOBJ)
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

all:	cppcheck testrunner

testrunner: $(TESTOBJ) $(LIBOBJ) $(EXTOBJ) cli/threadexecutor.o cli/cmdlineparser.o cli/cppcheckexecutor.o cli/filelister.o
	$(CXX) $(CPPFLAGS) $(CXXFLAGS) -o $@ $^ $(LIBS) $(LDFLAGS) $(RDYNAMIC)

test:	all
	./testrunner

check:	all
	./testrunner -q

checkcfg:	cppcheck validateCFG
	./test/cfg/runtests.sh

dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o externals/simplecpp/simplecpp.o
	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)

run-dmake: dmake
	./dmake

generate_cfg_tests: tools/generate_cfg_tests.o $(EXTOBJ)
	g++ -isystem externals/tinyxml -o generate_cfg_tests tools/generate_cfg_tests.o $(EXTOBJ)
clean:
	rm -f build/*.o lib/*.o cli/*.o test/*.o tools/*.o externals/*/*.o testrunner dmake cppcheck cppcheck.exe cppcheck.1

man:	man/cppcheck.1

man/cppcheck.1:	$(MAN_SOURCE)

	$(XP) $(DB2MAN) $(MAN_SOURCE)

tags:
	ctags -R --exclude=doxyoutput --exclude=test/cfg --exclude=test/synthetic cli externals gui lib test

install: cppcheck
	install -d ${BIN}
	install cppcheck ${BIN}
	install htmlreport/cppcheck-htmlreport ${BIN}
ifdef FILESDIR
	install -d ${DESTDIR}${FILESDIR}
	install -d ${DESTDIR}${FILESDIR}/addons
	install -m 644 addons/*.py ${DESTDIR}${FILESDIR}/addons
	install -d ${DESTDIR}${FILESDIR}/cfg
	install -m 644 cfg/*.cfg ${DESTDIR}${FILESDIR}/cfg
	install -d ${DESTDIR}${FILESDIR}/platforms
	install -m 644 platforms/*.xml ${DESTDIR}${FILESDIR}/platforms
else
	$(error FILESDIR must be set!)
endif

uninstall:
	@if test -d ${BIN}; then \
	  files="cppcheck cppcheck-htmlreport"; \
	  echo '(' cd ${BIN} '&&' rm -f $$files ')'; \
	  ( cd ${BIN} && rm -f $$files ); \
	fi
ifdef FILESDIR 
	@if test -d ${DESTDIR}${FILESDIR}; then \
	  echo rm -rf ${DESTDIR}${FILESDIR}; \
	  rm -rf ${DESTDIR}${FILESDIR}; \
	fi
endif
ifdef CFGDIR 
	@if test -d ${DESTDIR}${CFGDIR}; then \
	  files="`cd cfg 2>/dev/null && ls`"; \
	  if test -n "$$files"; then \
	    echo '(' cd ${DESTDIR}${CFGDIR} '&&' rm -f $$files ')'; \
	    ( cd ${DESTDIR}${CFGDIR} && rm -f $$files ); \
	  fi; \
	fi
endif

# Validation of library files:
ConfigFiles := $(wildcard cfg/*.cfg)
ConfigFilesCHECKED := $(patsubst %.cfg,%.checked,$(ConfigFiles))
.PHONY: validateCFG
%.checked:%.cfg
	xmllint --noout --relaxng cfg/cppcheck-cfg.rng $<
validateCFG: ${ConfigFilesCHECKED}
	xmllint --noout cfg/cppcheck-cfg.rng

# Validation of platforms files:
PlatformFiles := $(wildcard platforms/*.xml)
PlatformFilesCHECKED := $(patsubst %.xml,%.checked,$(PlatformFiles))
.PHONY: validatePlatforms
%.checked:%.xml
	xmllint --noout --relaxng platforms/cppcheck-platforms.rng $<
validatePlatforms: ${PlatformFilesCHECKED}

# Validate XML output (to detect regressions)
/tmp/errorlist.xml: cppcheck
	./cppcheck --errorlist >$@
/tmp/example.xml: cppcheck
	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h --max-configs=1 -j 4 cli externals gui lib test 2>/tmp/example.xml
createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
