=== debian/changelog ===
cppcheck (2.0-3) unstable; urgency=medium

  * Add patch fix-pythonhome (Closes: #961925).
  * Remove gdb from Build-Depends (unclear why it existed).
  * Fix lintian override for extra-license-file.
  * Set upstream metadata fields: Bug-Database, Repository, Repository-Browse
  * Add Vcs-* fields to debian/control.

 -- Joachim Reichel <reichel@debian.org>  Wed, 20 May 2020 21:21:17 +0200

cppcheck (2.0-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joachim Reichel <reichel@debian.org>  Wed, 20 May 2020 20:50:52 +0200

cppcheck (2.0-1) experimental; urgency=medium

  * New upstream release.
    - Remove patch adjust-warnings (applied upstream).
    - Update patch fix-default-settings.
    - Add patch fix-cmake.

 -- Joachim Reichel <reichel@debian.org>  Wed, 13 May 2020 18:22:43 +0200
