## cppcheck 2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -28,9 +28,10 @@
 add_subdirectory(lib)   # CppCheck Library 
 add_subdirectory(cli)   # Client application
 add_subdirectory(test)  # Tests
-ADD_SUBDIRECTORY(gui)   # Graphical application
-ADD_SUBDIRECTORY(tools/triage)   # Triage tool
+add_subdirectory(gui)   # Graphical application
+add_subdirectory(tools/triage)   # Triage tool
 add_subdirectory(oss-fuzz) # OSS-Fuzz clients
+add_subdirectory(tools)
 
 include(cmake/printInfo.cmake)
 include(cmake/clang_tidy.cmake)
