=== Makefile ===
--- 
+++ 
@@ -188,6 +188,7 @@
               $(libcppdir)/cppcheck.o \
               $(libcppdir)/ctu.o \
               $(libcppdir)/errorlogger.o \
+              $(libcppdir)/errortypes.o \
               $(libcppdir)/exprengine.o \
               $(libcppdir)/forwardanalyzer.o \
               $(libcppdir)/importproject.o \
@@ -207,6 +208,7 @@
               $(libcppdir)/token.o \
               $(libcppdir)/tokenize.o \
               $(libcppdir)/tokenlist.o \
+              $(libcppdir)/utils.o \
               $(libcppdir)/valueflow.o
 
 EXTOBJ =      externals/simplecpp/simplecpp.o \
@@ -304,7 +306,7 @@
 checkcfg:	cppcheck validateCFG
 	./test/cfg/runtests.sh
 
-dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o externals/simplecpp/simplecpp.o
+dmake:	tools/dmake.o cli/filelister.o $(libcppdir)/pathmatch.o $(libcppdir)/path.o $(libcppdir)/utils.o externals/simplecpp/simplecpp.o
 	$(CXX) $(CXXFLAGS) -o $@ $^ $(LDFLAGS)
 
 run-dmake: dmake
@@ -383,5 +385,4 @@
 /tmp/errorlist.xml: cppcheck
 	./cppcheck --errorlist >$@
 /tmp/example.xml: cppcheck
-	./cppcheck --xml --enable=all --inconclusive --suppress=operatorEqVarError:*check.h --max-configs=1 -j 4 cli externals gui lib test 2>/tmp/example.xml
-createXMLExamples:/tmp/errorlist.xml /tmp/example.xml
+	./cppcheck --xml --enable=all --inconclusive --max-configs=1 samples 2>/tmp/example.xml
