=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -22,7 +22,10 @@
 
     add_executable(cppcheck-gui ${hdrs} ${srcs} ${uis_hdrs} ${resources} ${qms} $<TARGET_OBJECTS:lib_objs> $<TARGET_OBJECTS:tinyxml_objs> $<TARGET_OBJECTS:simplecpp_objs>)
     if (HAVE_RULES)
-        target_link_libraries(cppcheck-gui pcre)
+        target_link_libraries(cppcheck-gui ${PCRE_LIBRARY})
+    endif()
+    if (USE_Z3)
+        target_link_libraries(cppcheck-gui ${Z3_LIBRARIES})
     endif()
     target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
     if(WITH_QCHART)
