=== debian/changelog ===
cppcheck (2.1-1) unstable; urgency=medium

  * New upstream release.
    - Remove patch fix-cmake (applied upstream).
    - Remove patch fix-pythonhome (superseded upstream).
    - Update patch fix-default-settings.
    - Add patch fix-y2038.

 -- Joachim Reichel <reichel@debian.org>  Thu, 18 Jun 2020 18:54:23 +0200
