## cppcheck 2.2

=== Makefile ===
--- 
+++ 
@@ -158,6 +158,7 @@
 
 LIBOBJ =      $(libcppdir)/analyzerinfo.o \
               $(libcppdir)/astutils.o \
+              $(libcppdir)/bughuntingchecks.o \
               $(libcppdir)/check.o \
               $(libcppdir)/check64bit.o \
               $(libcppdir)/checkassert.o \
@@ -228,6 +229,7 @@
               test/testbool.o \
               test/testboost.o \
               test/testbufferoverrun.o \
+              test/testbughuntingchecks.o \
               test/testcharvar.o \
               test/testclangimport.o \
               test/testclass.o \
@@ -385,4 +387,3 @@
 /tmp/errorlist.xml: cppcheck
 	./cppcheck --errorlist >$@
 /tmp/example.xml: cppcheck
-	./cppcheck --xml --enable=all --inconclusive --max-configs=1 samples 2>/tmp/example.xml
