=== gui/CMakeLists.txt ===
--- 
+++ 
@@ -27,7 +27,7 @@
     if (USE_Z3)
         target_link_libraries(cppcheck-gui ${Z3_LIBRARIES})
     endif()
-    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport)
+    target_link_libraries(cppcheck-gui Qt5::Core Qt5::Gui Qt5::Widgets Qt5::PrintSupport Qt5::Help)
     if(WITH_QCHART)
         target_compile_definitions (cppcheck-gui PRIVATE HAVE_QCHART )
         target_link_libraries(cppcheck-gui Qt5::Charts)
