=== lib/CMakeLists.txt ===
--- 
+++ 
@@ -37,7 +37,13 @@
 endif()
 
 add_library(lib_objs OBJECT ${srcs_lib} ${hdrs})
+if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+    target_precompile_headers(lib_objs PRIVATE precompiled.h)
+endif()
 if (ENABLE_OSS_FUZZ AND CMAKE_CXX_COMPILER_ID MATCHES "Clang")
     add_library(lib_objs_sanitized OBJECT EXCLUDE_FROM_ALL ${srcs_lib} ${hdrs})
     target_compile_options(lib_objs_sanitized PRIVATE -fsanitize=address)
+    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+        target_precompile_headers(lib_objs_sanitized PRIVATE precompiled.h)
+    endif()
 endif()
