=== test/CMakeLists.txt ===
--- 
+++ 
@@ -25,6 +25,10 @@
     endif()
     if (USE_Z3)
         target_link_libraries(testrunner ${Z3_LIBRARIES})
+    endif()
+
+    if (NOT CMAKE_DISABLE_PRECOMPILE_HEADERS)
+        target_precompile_headers(testrunner PRIVATE precompiled.h)
     endif()
 
     add_custom_target(copy_cfg ALL
