=== debian/changelog ===
cppcheck (2.2-1) unstable; urgency=medium

  * New upstream release (Closes: #966386).
  * Add Suggests: clang to cppcheck, and Suggests: clang-tidy to cppcheck
    and cppcheck-gui.
  * Remove patch fix-y2038 (superseded upstream).
  * Update patch fix-translation-loading.

 -- Joachim Reichel <reichel@debian.org>  Sun, 11 Oct 2020 17:42:26 +0200
