=== debian/control ===
--- 
+++ 
@@ -28,7 +28,7 @@
 Package: cppcheck
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}, python3-pygments
-Suggests: cppcheck-gui
+Suggests: cppcheck-gui, clang, clang-tidy
 Description: tool for static C/C++ code analysis (CLI)
  Cppcheck is a command-line tool that tries to detect bugs that your
  C/C++ compiler doesn't see. It is versatile, and can check non-standard
@@ -68,7 +68,7 @@
 Package: cppcheck-gui
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, cppcheck (= ${binary:Version})
-Suggests: python3, clang
+Suggests: python3, clang, clang-tidy
 Description: tool for static C/C++ code analysis (GUI)
  Cppcheck is a command-line tool that tries to detect bugs that your
  C/C++ compiler doesn't see. It is versatile, and can check non-standard
